"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from plex_api_client import utils
from plex_api_client.types import BaseModel
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class MarkUnplayedMediaErrorsTypedDict(TypedDict):
    code: NotRequired[int]
    message: NotRequired[str]
    status: NotRequired[int]


class MarkUnplayedMediaErrors(BaseModel):
    code: Optional[int] = None

    message: Optional[str] = None

    status: Optional[int] = None


class MarkUnplayedUnauthorizedData(BaseModel):
    errors: Optional[List[MarkUnplayedMediaErrors]] = None

    raw_response: Annotated[Optional[httpx.Response], pydantic.Field(exclude=True)] = (
        None
    )
    r"""Raw HTTP response; suitable for custom response parsing"""


class MarkUnplayedUnauthorized(Exception):
    r"""Unauthorized - Returned if the X-Plex-Token is missing from the header or query."""

    data: MarkUnplayedUnauthorizedData

    def __init__(self, data: MarkUnplayedUnauthorizedData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, MarkUnplayedUnauthorizedData)


class MarkUnplayedErrorsTypedDict(TypedDict):
    code: NotRequired[int]
    message: NotRequired[str]
    status: NotRequired[int]


class MarkUnplayedErrors(BaseModel):
    code: Optional[int] = None

    message: Optional[str] = None

    status: Optional[int] = None


class MarkUnplayedBadRequestData(BaseModel):
    errors: Optional[List[MarkUnplayedErrors]] = None

    raw_response: Annotated[Optional[httpx.Response], pydantic.Field(exclude=True)] = (
        None
    )
    r"""Raw HTTP response; suitable for custom response parsing"""


class MarkUnplayedBadRequest(Exception):
    r"""Bad Request - A parameter was not specified, or was specified incorrectly."""

    data: MarkUnplayedBadRequestData

    def __init__(self, data: MarkUnplayedBadRequestData):
        self.data = data

    def __str__(self) -> str:
        return utils.marshal_json(self.data, MarkUnplayedBadRequestData)
