"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from plex_api_client.types import BaseModel
from plex_api_client.utils import FieldMetadata, PathParamMetadata, QueryParamMetadata
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class AddPlaylistContentsRequestTypedDict(TypedDict):
    playlist_id: float
    r"""the ID of the playlist"""
    uri: str
    r"""the content URI for the playlist"""
    play_queue_id: NotRequired[float]
    r"""the play queue to add to a playlist"""


class AddPlaylistContentsRequest(BaseModel):
    playlist_id: Annotated[
        float,
        pydantic.Field(alias="playlistID"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""the ID of the playlist"""

    uri: Annotated[
        str, FieldMetadata(query=QueryParamMetadata(style="form", explode=True))
    ]
    r"""the content URI for the playlist"""

    play_queue_id: Annotated[
        Optional[float],
        pydantic.Field(alias="playQueueID"),
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""the play queue to add to a playlist"""


class AddPlaylistContentsMetadataTypedDict(TypedDict):
    rating_key: NotRequired[str]
    key: NotRequired[str]
    guid: NotRequired[str]
    type: NotRequired[str]
    title: NotRequired[str]
    summary: NotRequired[str]
    smart: NotRequired[bool]
    playlist_type: NotRequired[str]
    composite: NotRequired[str]
    duration: NotRequired[int]
    leaf_count: NotRequired[int]
    added_at: NotRequired[int]
    updated_at: NotRequired[int]


class AddPlaylistContentsMetadata(BaseModel):
    rating_key: Annotated[Optional[str], pydantic.Field(alias="ratingKey")] = None

    key: Optional[str] = None

    guid: Optional[str] = None

    type: Optional[str] = None

    title: Optional[str] = None

    summary: Optional[str] = None

    smart: Optional[bool] = None

    playlist_type: Annotated[Optional[str], pydantic.Field(alias="playlistType")] = None

    composite: Optional[str] = None

    duration: Optional[int] = None

    leaf_count: Annotated[Optional[int], pydantic.Field(alias="leafCount")] = None

    added_at: Annotated[Optional[int], pydantic.Field(alias="addedAt")] = None

    updated_at: Annotated[Optional[int], pydantic.Field(alias="updatedAt")] = None


class AddPlaylistContentsMediaContainerTypedDict(TypedDict):
    size: NotRequired[int]
    leaf_count_added: NotRequired[int]
    leaf_count_requested: NotRequired[int]
    metadata: NotRequired[List[AddPlaylistContentsMetadataTypedDict]]


class AddPlaylistContentsMediaContainer(BaseModel):
    size: Optional[int] = None

    leaf_count_added: Annotated[
        Optional[int], pydantic.Field(alias="leafCountAdded")
    ] = None

    leaf_count_requested: Annotated[
        Optional[int], pydantic.Field(alias="leafCountRequested")
    ] = None

    metadata: Annotated[
        Optional[List[AddPlaylistContentsMetadata]], pydantic.Field(alias="Metadata")
    ] = None


class AddPlaylistContentsResponseBodyTypedDict(TypedDict):
    r"""Playlist Updated"""

    media_container: NotRequired[AddPlaylistContentsMediaContainerTypedDict]


class AddPlaylistContentsResponseBody(BaseModel):
    r"""Playlist Updated"""

    media_container: Annotated[
        Optional[AddPlaylistContentsMediaContainer],
        pydantic.Field(alias="MediaContainer"),
    ] = None


class AddPlaylistContentsResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    object: NotRequired[AddPlaylistContentsResponseBodyTypedDict]
    r"""Playlist Updated"""


class AddPlaylistContentsResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    object: Optional[AddPlaylistContentsResponseBody] = None
    r"""Playlist Updated"""
