"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
import httpx
from plex_api_client.types import BaseModel
from plex_api_client.utils import FieldMetadata, QueryParamMetadata
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class Tonight(int, Enum):
    r"""Indicate that you want the update to run during the next Butler execution. Omitting this or setting it to false indicates that the update should install"""

    ZERO = 0
    ONE = 1


class Skip(int, Enum):
    r"""Indicate that the latest version should be marked as skipped. The [Release] entry for this version will have the `state` set to `skipped`."""

    ZERO = 0
    ONE = 1


class ApplyUpdatesRequestTypedDict(TypedDict):
    tonight: NotRequired[Tonight]
    r"""Indicate that you want the update to run during the next Butler execution. Omitting this or setting it to false indicates that the update should install"""
    skip: NotRequired[Skip]
    r"""Indicate that the latest version should be marked as skipped. The [Release] entry for this version will have the `state` set to `skipped`."""


class ApplyUpdatesRequest(BaseModel):
    tonight: Annotated[
        Optional[Tonight],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Indicate that you want the update to run during the next Butler execution. Omitting this or setting it to false indicates that the update should install"""

    skip: Annotated[
        Optional[Skip],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Indicate that the latest version should be marked as skipped. The [Release] entry for this version will have the `state` set to `skipped`."""


class ApplyUpdatesResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""


class ApplyUpdatesResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
