"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
from enum import Enum
import httpx
from plex_api_client.types import BaseModel
from plex_api_client.utils import FieldMetadata, QueryParamMetadata
from typing import Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class Download(int, Enum):
    r"""Indicate that you want to start download any updates found."""

    ZERO = 0
    ONE = 1


class CheckForUpdatesRequestTypedDict(TypedDict):
    download: NotRequired[Download]
    r"""Indicate that you want to start download any updates found."""


class CheckForUpdatesRequest(BaseModel):
    download: Annotated[
        Optional[Download],
        FieldMetadata(query=QueryParamMetadata(style="form", explode=True)),
    ] = None
    r"""Indicate that you want to start download any updates found."""


class CheckForUpdatesResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""


class CheckForUpdatesResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
