"""Code generated by Speakeasy (https://speakeasy.com). DO NOT EDIT."""

from __future__ import annotations
import httpx
from plex_api_client.types import BaseModel
from plex_api_client.utils import FieldMetadata, PathParamMetadata
import pydantic
from typing import List, Optional
from typing_extensions import Annotated, NotRequired, TypedDict


class GetMediaPostersRequestTypedDict(TypedDict):
    rating_key: int
    r"""the id of the library item to return the posters of."""


class GetMediaPostersRequest(BaseModel):
    rating_key: Annotated[
        int,
        pydantic.Field(alias="ratingKey"),
        FieldMetadata(path=PathParamMetadata(style="simple", explode=False)),
    ]
    r"""the id of the library item to return the posters of."""


class GetMediaPostersMetadataTypedDict(TypedDict):
    key: str
    r"""The URL of the poster."""
    rating_key: str
    r"""The URL of the poster."""
    selected: bool
    r"""Whether this is the selected poster."""
    thumb: str
    r"""The URL of the poster thumbnail."""
    provider: NotRequired[str]
    r"""The provider of the poster."""


class GetMediaPostersMetadata(BaseModel):
    key: str
    r"""The URL of the poster."""

    rating_key: Annotated[str, pydantic.Field(alias="ratingKey")]
    r"""The URL of the poster."""

    selected: bool
    r"""Whether this is the selected poster."""

    thumb: str
    r"""The URL of the poster thumbnail."""

    provider: Optional[str] = None
    r"""The provider of the poster."""


class GetMediaPostersMediaContainerTypedDict(TypedDict):
    size: int
    r"""Number of media items returned in this response."""
    media_tag_version: int
    r"""The version number for media tags."""
    media_tag_prefix: str
    r"""The prefix used for media tag resource paths."""
    identifier: str
    r"""An plugin identifier for the media container."""
    metadata: List[GetMediaPostersMetadataTypedDict]


class GetMediaPostersMediaContainer(BaseModel):
    size: int
    r"""Number of media items returned in this response."""

    media_tag_version: Annotated[int, pydantic.Field(alias="mediaTagVersion")]
    r"""The version number for media tags."""

    media_tag_prefix: Annotated[str, pydantic.Field(alias="mediaTagPrefix")]
    r"""The prefix used for media tag resource paths."""

    identifier: str
    r"""An plugin identifier for the media container."""

    metadata: Annotated[List[GetMediaPostersMetadata], pydantic.Field(alias="Metadata")]


class GetMediaPostersResponseBodyTypedDict(TypedDict):
    r"""The available posters for the library item."""

    media_container: NotRequired[GetMediaPostersMediaContainerTypedDict]


class GetMediaPostersResponseBody(BaseModel):
    r"""The available posters for the library item."""

    media_container: Annotated[
        Optional[GetMediaPostersMediaContainer], pydantic.Field(alias="MediaContainer")
    ] = None


class GetMediaPostersResponseTypedDict(TypedDict):
    content_type: str
    r"""HTTP response content type for this operation"""
    status_code: int
    r"""HTTP response status code for this operation"""
    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""
    object: NotRequired[GetMediaPostersResponseBodyTypedDict]
    r"""The available posters for the library item."""


class GetMediaPostersResponse(BaseModel):
    content_type: str
    r"""HTTP response content type for this operation"""

    status_code: int
    r"""HTTP response status code for this operation"""

    raw_response: httpx.Response
    r"""Raw HTTP response; suitable for custom response parsing"""

    object: Optional[GetMediaPostersResponseBody] = None
    r"""The available posters for the library item."""
